package com.spookyinternet.cobweb;

import java.io.*;
import java.util.*;

class HttpTokenStream implements Iterator<HttpToken> {
  private String payload;
  private int idx;
  private int marker;
  private int line;
  private int seq;

  public HttpTokenStream(BufferedReader reader) {
    char[] buff = new char[4096];
    int amt = 0;

    try {
      amt = reader.read(buff, 0, buff.length);
    } catch(Exception _) {
      // :)
    }

    this.payload = new String(buff, 0, amt);
    this.idx = 1;
    this.marker = 0;
    this.line = 1;
    this.seq = 1;
  }

  @Override
  public boolean hasNext() {
    return this.idx < this.payload.length();
  }

  @Override
  public HttpToken next() {
    HttpToken token = new HttpToken(this.line, this.seq, null, this.seq == 1, false);
    this.seq += 1;

    while(this.idx < this.payload.length()) {
      char rune1 = this.payload.charAt(this.idx - 1);
      char rune2 = this.payload.charAt(this.idx);
      int snapshot_idx = this.idx;
      this.idx += 1;

      if(Character.isWhitespace(rune1) != Character.isWhitespace(rune2)) {
        token.value = this.payload.substring(this.marker, snapshot_idx);
        this.marker = snapshot_idx;
        return token;
      } else if(rune2 == '\n') {
        token.value = this.payload.substring(this.marker, this.idx);
        this.marker = this.idx;
        this.idx += 1;
        this.line += 1;
        this.seq = 1;
        token.eol = true;
        return token;
      }
    }

    token.value = this.payload.substring(this.marker);
    token.eol = token.value.endsWith("\n");
    return token;
  }
}
